LeetCode-746. Min Cost Climbing Stairs(DP)

746. Min Cost Climbing Stairs

题目

On a staircase, the i-th step has some non-negative cost cost[i] assigned (0 indexed).

Once you pay the cost, you can either climb one or two steps. You need to find minimum cost to reach the top of the floor, and you can either start from the step with index 0, or the step with index 1.

Example 1:

Input: cost = [10, 15, 20]
Output: 15
Explanation: Cheapest is start on cost[1], pay that cost and go to the top.

Example 2:

Input: cost = [1, 100, 1, 1, 1, 100, 1, 1, 100, 1]
Output: 6
Explanation: Cheapest is start on cost[0], and only step on 1s, skipping cost[3].

Note:

cost will have a length in the range [2, 1000].
Every cost[i] will be an integer in the range [0, 999].

算法

典型的动态规划问题,虽说是动态规划,但还是经常想不通正确的递推公式,没有头绪,应该还是因为练的太少了吧…
这道题的思路就是,从后往前推,一定是从倒数第一个或者倒数第二个台阶迈出去的,所以从倒数第一个迈出去的开销就是cost[costSize-1],从倒数第二个迈出去的开销就是cost[costSize-2],然后再往前从第i个台阶到最后的开销就遵循: f [ i ] = c o s t [ i ] + m i n ( f [ i + 1 ] , f [ i + 2 ] ) f[i] = cost[i] + min(f[i+1], f[i+2]) ,因为可以从第0或者第1个台阶开始,比较一下 f [ 0 ] f[0] f [ 1 ] f[1] 的大小就好,选择最小的那个就是最后的答案

代码

int minCostClimbingStairs(int* cost, int costSize) {
    int i;
    int f[1000];
    f[costSize-1] = cost[costSize-1];
    f[costSize-2] = cost[costSize-2];
    for(i=costSize-3;i>=0;i--){
        int min = f[i+1];
        if(f[i+2]<min)min = f[i+2];
        f[i] = cost[i]+min;
    }
    if(f[0]>f[1]){
        return f[1];
    }
    return f[0];
}

猜你喜欢

转载自blog.csdn.net/weixin_41580638/article/details/88118496